#!/usr/bin/env python3

try:
    from Quartz import CGWindowListCopyWindowInfo, kCGWindowListExcludeDesktopElements, kCGNullWindowID
except ModuleNotFoundError:
    print('macOS specific Python module ''Quartz'' not found.')
    print('Please install it via pip:')
    print()
    print('  pip install pyobjc-framework-Quartz')
    raise

from Foundation import NSSet, NSMutableSet
import os
import time


wl1 = CGWindowListCopyWindowInfo(kCGWindowListExcludeDesktopElements, kCGNullWindowID)
print('Move target window (within 3 seconds)...')
time.sleep(3)
print()

wl2 = CGWindowListCopyWindowInfo(kCGWindowListExcludeDesktopElements, kCGNullWindowID)
w = NSMutableSet.setWithArray_(wl1)
w.minusSet_(NSSet.setWithArray_(wl2))

s = str(w)
if 'PID' in s:
    pid = s.split('PID = ')[1].split(';')[0]
    print(f'Moved window belongs to process with ID (PID): {pid}')
    print()
    cmd = f'ps -p {pid}'
    print(f'Process information (\'{cmd}\'):')
    print()
    os.system(cmd)
else:
    print('No moved window found.')
print()
